# Intro til GIT med Eclipse (og i terminal)

[Git](https://git-scm.com) er et system for versjonskontroll av kode (og andre tekstfiler), som er veldig mye brukt, både i diverse fag ved NTNU og i arbeidslivet.
Det er et veldig kraftig verktøy, men kan ofte bli litt overveldende i starten.
Derfor har vi laget denne guiden.
Den vil gå gjennom de grunnleggende delene av git, og hvordan du bruker det både i Eclipse og i kommandolinja.
For en del vil Eclipse være enklest, og det vil sannsynligvis fungere helt fint i dette faget.
Allikevel kommer mange til å trenge å lære seg å bruke git i kommandolinja på et senere tidspunkt, så dette kan være en god mulighet til å prøve det ut.

## Sjekk at git er installert (trengs ikke om du vil bruke Eclipse)
Før du begynner å installere git kan du se om du allerede har det.
Det er lite sannsynlig på Windows, mens på MacOS og Linux brukes det til en del, så det kan hende du har det.
Dersom du må installere git kan du laste det ned fra [nettsidene til git](https://git-scm.com/downloads).

### Windows
Sjekk om du har programmet *git bash* innstallert.
Hvis ikke har du (sannsynligvis) ikke git installert.

### MacOS/Linux/*nix
Åpne en terminal og prøv å skrive inn 
```bash
git
```
Om du får opp en lang side med info om git har du det installert.
Om du får beskjed om at kommandoen ikke finnes må du innstallere det.

## Innhold

- [Del 1: Intro til git](basics.md): Går gjennom hva git er og, på et høyt nivå, hvordan det fungerer.
- [Del 2: Git operasjoner](operasjoner.md): Går gjennom hvordan man utfører de viktigste git-operasjonene i Eclipse og terminalen.
- [Del 3: HJELP!!!](hjelp.md): Går gjennom hvordan man løser vanlige problemer i git.
- [Del 4: Tips og triks](tips_trisk.md): Går gjennom noen nyttige tips og triks i git.